use strict;
use XML::Twig;

my $xml_file=$ARGV[0];

my $twig= new XML::Twig( 
                twig_handlers =>{ 
                		S => \&sentence 
                		},
                pretty_print => 'indented'     
                );                        

$twig->parsefile($xml_file);    
$twig->print;                   

sub sentence{ 
 my( $twig, $s)= @_;                      

    $s->wrap_in(seg =>{rule => 'rule1'});     # wrap sentence

	&rule_8($s);

	&rule_2($s,"[","]");
	&rule_2($s,"(",")");
	&rule_2($s,"{","}");
# TO DO : problems with symetrical markers like "-"

	&rule_3($s);
	
	&rule_4_1($s);
	&rule_4_2($s);
		
    $twig->flush;
}

sub rule_2{
	my $tag="rule2";
	my ($s,$lm,$rm,$r)=@_;
    my $lp=0; my $seg; my $verb=0; 
    my @seg;  
    my @children=$s->children; 
    for my $g (@children){
        if ($g->text eq "$lm"){
	    	$lp++;
	    	$seg=$g;
        }
		if($lp && $g->gi =~ /(ger)|(verb)|(vaux)/){
			$verb++;
		} 
		if($lp){
			push(@seg,$g);
		}		
        if($g->text eq "$rm" && --$lp == 0){
        	if($verb){
				for my $s (@seg){
					$s->cut;
				}
        		$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
			}
			$verb=0; @seg=();
		}
	}
	return $s;
}

sub rule_3{
	my $tag="rule3";
	my ($s,$r)=@_;
	my $lm=",";
    my $lp; my $seg; my $verb=0; my $prev="NULL";
    my @seg;   
    my @children=$s->children; 
    for my $g (@children){
 		if($prev eq $lm && $g->gi =~ /(forma_ger)|(ger_pas)/){
			$lp++;
		} 
		if($lp){
			push(@seg,$g);
		}		
        if($g->text eq $lm && $lp){
			for my $s (@seg){
				$s->cut;
			}
        	$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
			$lp=0; @seg=();
		}
		$prev=$g->text;
	}
	return $s;
}

##############################################
# ATTENTION                                  #
# Rules 4, 5 and 7 have been merged together #
##############################################

sub rule_4_1{
	my $tag="rule4.1";
	my ($s,$r)=@_;
    my $lp=0; my $seg; my $verbp =0; my $verbn=0; my $prev="NULL";
    my @seg;   
    my @children=$s->children; 
    for my $g (@children){
 		if($verbp && (($g->gi =~ /(coord)|(conj-subord)|(disc_mk)/ && $g->text ne "que") || $g->text eq "para")){
#################################
# Uncoment this to cut before next preposition
#			if($lp && $verbn && $verbp){
#				for my $s (@seg){
#					$s->cut;
#				}
#        		$g->insert_new_elt('before', seg => { rule => $tag },@seg);
#				q$verbn=0; @seg=();		
#			} 
###################################
			if(!$lp){$prev=$g;} # remember first preposition appearance after some verb.
			$lp=1; 
		} 
		if($lp){
			push(@seg,$g);
		}		
		if($g->gi =~ /(ger)|(verb)|(vaux)/){
			if($lp){$verbn++;}
			else{$verbp++}
		} 
	}
    if($lp && $verbn && $verbp){
		for my $s (@seg){
			$s->cut;
		}
       	$prev->former_prev_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
	}	
	return $s;
}

sub rule_4_2{
	my $tag="rule4.2";
	my ($s,$r)=@_;
	my $rp=",";
    my $lp=1; my $seg; my $verbp =0; my $verbn=0; my $verbinf; my $prev="NULL";
    my @seg;   
    my @children=$s->children;
    my $g0=$children[0];
    if(($g0->gi =~ /(coord)|(conj_subord)|(disc_mk)/ && $g0->text ne "Que")
    ||($g0->text eq "Para")){
	    for my $g (@children){
	    	if($lp){
				push(@seg,$g);
			}	
 			if($lp && $g->text eq $rp && $verbp){
				if(($g0->text ne "Para")||($verbp>1)){
					$prev=$g; # remember end of sub.
					$lp=0;
				}
			}
			if($g->gi =~ /(ger)|(verb)|(vaux)/){
				if($lp){
					$verbp++;		
				}
				else{
					$verbn++;
				}
			}
		}
		if(!$lp && $verbn && $verbp){
			for my $s (@seg){
				$s->cut;
			}
			$prev->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
		}	
	}
	return $s;
}

sub rule_8{
	my $tag="rule8";
	my ($s,$r)=@_;
	my $rp=",";
    my $lp=1; 
    my @children=$s->children;
    my $i=1;
    my $t=1; 
    my $g=$children[0];
    my @seg=($g);
    while ($t && ($i<@children-1)){
    	$g=$children[$i]; 
    	if(($g->gi =~ /F_no_c/) && ($g->text =~ /\:$/) && ($g->next_sibling->gi=~/grup_verb_inf/)){
    		$t=0;
		}
 		push(@seg,$g);
 		$i++;
	}
	if (!$t){
		my $s;
		for $s (@seg){
			$s->cut;
		}
		$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);

		@seg=();
		while ($i<@children-1){
			$g=$children[$i];
			$i++;
			my $c=0;
			if($g->next_sibling->gi=~/grup_verb_inf/){
				if($g->text eq $rp){
					push(@seg,$g);					
					for my $s (@seg){
						$s->cut;
					}	
					$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
					@seg=();
				}
				elsif($g->text eq "y"){
					for my $s (@seg){
						$s->cut;
					}
					my $elt=$g->insert_new_elt('before', seg => { rule => $tag },@seg);
					@seg=($g);
				}
				else{push(@seg,$g);}
			}
			else{push(@seg,$g);}	 
		}
		if(@seg>1){
			for my $s (@seg){
				$s->cut;
				}
			$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
		}
	}
	return $s;
}
