use strict;
use XML::Twig;

my $REC=1;
my $O;
my $xml_file=$ARGV[0];
my $twig= new XML::Twig( 
                twig_handlers =>{ 
		    seg => \&sentence 
		    },
			 pretty_print => 'indented',
                         keep_encoding => 1     
                );                        

my $p=0;
my $N=0;
while($N++<2){
    $p=$REC;
    open(my $X,$xml_file);
    my $output=$xml_file;
    $output=~ s/segI/seg$N/; 
    open($O,">$output");
    $twig->parse($X);
    $twig->flush($O);    
    $twig->print($O);
    close($X);
    close($O);
    my $xml_file=$output;
}                   


sub sentence{ 
    my( $twig, $s)= @_;                      
    my $D=0;
    $D+=&rule_2($s,"[","]");
    $D+=&rule_2($s,"(",")");
    $D+=&rule_2($s,"{","}");
    $D+=&rule_3($s);
    $D+=&rule_4_1($s);
    $D+=&rule_4_2($s);
    $D+=&rule_8($s);	
    $twig->flush($O);
    $REC += $D;
}

sub rule_2{
    my $tag="rule2";
    my ($s,$lm,$rm,$r)=@_;
    my $lp=0; my $seg; my $verb=0; 
    my @seg;  
    my @children=$s->children;
    my $b=0; 
    for my $g (@children){
        if ($g->text eq "$lm"){
	    $lp++;
	    $seg=$g;
	}
	if($lp && $g->gi =~ /(ger)|(verb)|(vaux)/){
	    $verb++;
	} 
	if($lp){
	    push(@seg,$g);
	}		
        if($g->text eq "$rm" && --$lp == 0){
	    if($verb){
		for my $s (@seg){
		    $s->cut;
		}
		$g->former_next_sibling->insert_new_elt('before', seg => { rule => $tag },@seg);
		$b++;
	    }
	    $verb=0; @seg=();
	}
    }
#    print "This b=$b\n";
    return $b;
}

sub rule_3{
    my $tag="rule3";
    my ($s,$r)=@_;
    my $lm=",";
    my $lp; my $seg; my $verb=0; my $prev="NULL";
    my $b=0;
    my @seg;   
    my @children=$s->children;
    my $i; 
    for my $g (@children){
	$i++;
	if($prev eq $lm && ($g->gi =~ /(forma_ger)|(ger_pas)/|| $g->gi eq "ger")){
	    $lp++;
	    $seg=$g;
		} 
        if(($g->text eq $lm || $i==@children) && $lp){
	    $seg->cut;
	    $seg->former_next_sibling->insert_new_elt('before', segD => { rule => $tag },$seg);
	    $b++;
	    $lp=0; @seg=();
	    $seg="";
	}
	$prev=$g->text;
    }
    return $b;
}

##############################################
# ATTENTION                                  #
# Rules 4, 5 and 7 have been merged together #
##############################################

sub rule_4_1{
    my $tag="rule4.1";
    my ($s,$r)=@_;
    my $lp=0; my $seg; my $verbp =0; my $verbn=0; my $prev="NULL";
    my @seg;   
    my @children=$s->children; 
    my $b=0;
    my $i=0;
    for my $g (@children){
# Test if previous sibling is a period.
	my $period=0;
	if($i){
	    my $prev=$children[$i-1];
	    if($prev->text=~/[,;:\.]/){
		$period=1;
	    }
	}
	$i++;
	if($verbp && ((($g->gi =~ /(coord)|(conj_subord)|(grup_sp_inf)/ || ($g->gi =~ /disc_mk/ && $period) ) && $g->text ne "que") || $g->text eq "para")){
# feb 9 : No more using lists for segD 
#################################
# Uncoment this to cut before next preposition
	    if($lp && $verbn && $verbp){
# feb 9 : No more using lists for segD 
#				for my $s (@seg){
#					$s->cut;
#				}
		$seg->cut;
		$seg->former_prev_sibling->insert_new_elt('after', segD => { rule => $tag },$seg);
		$verbn=0;		
	    } 
###################################
	    $seg=$g;
	    $lp=1; 
	} 
# feb 9 : No more using lists for segD 
#	if($lp){
#	    push(@seg,$g);
#	}		
	if($g->gi =~ /(ger)|(verb)|(vaux)|(grup_sp_inf)/){
	    if($lp){$verbn++;}
	    else{$verbp++}
	} 
    }
    if($lp && $verbn && $verbp){
	    $seg->cut;
      	$seg->former_prev_sibling->insert_new_elt('after', segD => { rule => $tag },$seg);
	$b++;
    }	
    return $b;
}

sub rule_4_2{
    my $tag="rule4.2";
    my ($s,$r)=@_;
    my $rp=",";
    my $lp=1; my $seg; my $verbp =0; my $verbn=0; my $verbinf; my $prev="NULL";
    my @seg;   
    my @children=$s->children;
    my $g0=$children[0];
    my $b=0;
    if(($g0->gi =~ /(coord)|(conj_subord)|(disc_mk)/ && $g0->text ne "Que")
    ||($g0->text eq "Para")||($g0->gi =~ /forma_ger/)){
	$seg=$g0;
	for my $g (@children){
	    if($lp && ($g->text eq $rp || $g->gi eq "Fc")  && ($verbp || $g0->text eq "Para")){
#		if(($g0->text eq "Para")||($g0->gi =~ /forma_ger/)||($verbp>1)){
		$prev=$g; # remember end of sub.
		$lp=0;
#		}
	    }
	    if($g->gi =~ /(ger)|(verb)|(vaux)/){
		if($lp){
		    $verbp++;		
		}
		else{
		    $verbn++;
		}
	    }
	}
	if(!$lp && $verbn && $verbp){
		$prev->cut;
		$prev->former_next_sibling->insert_new_elt('before', segD => { rule => $tag },$prev);
	    $b++;
	}	
    }
    return $b;
}

sub rule_8{
    my $tag="rule8";
    my ($s,$r)=@_;
    my $rp=",";
    my $lp=1; 
    my @children=$s->children;
    if(@children){
	my $i=1;
	my $t=1; 
	my $g=$children[0];
	my @seg=($g);
	my $b=0;
	while ($t && ($i<@children-1)){
	    $g=$children[$i]; 
	    if(($g->gi =~ /F_no_c/) && ($g->text =~ /\:$/) && ($g->next_sibling->gi=~/grup_verb_inf/)){
		$t=0;
	    }
# feb 9 : No more using lists for segD 
#	push(@seg,$g);
	    $i++;
	}
	if (!$t){
	    if(my $s=shift(@seg)){
		$s->cut;
# feb 9 : No more using lists for segD 
		$s->former_next_sibling->insert_new_elt('before', segD => { rule => $tag },$s);
		$b++;
	    }	    
	    @seg=();
	    while ($i<@children-1){
		$g=$children[$i];
		$i++;
		my $c=0;
		if($g->next_sibling->gi=~/grup_verb_inf/){
		    if($g->text eq $rp || $g->gi eq "Fc"){
# feb 9 : No more using lists for segD 
#		    push(@seg,$g);					
		    if(my $s=shift(@seg)){
			$s->cut;	
# feb 9 : No more using lists for segD 
			$s->former_next_sibling->insert_new_elt('before', segD => { rule => $tag },@seg);
		    }
		    @seg=();
		    }
		    elsif($g->text eq "y"){
			for my $s (@seg){
			    $s->cut;
			}
			my $elt=$g->insert_new_elt('before', segD => { rule => $tag },$s);
			@seg=($g);
		}
# feb 9 : No more using lists for segD 
#		else{push(@seg,$g);}
		}
#	    else{push(@seg,$g);}	 
	    }
	    if(my $s = shift (@seg)){
		$s->cut;
# feb 9 : No more using lists for segD 
		$s->former_next_sibling->insert_new_elt('before', segD => { rule => $tag },$s);
		$b++;		
	    }
	}
    }
#    print "This b=$b\n";
    return $b;
}
